include:
{%- set os=grains['os'] -%}
{%- if os=="CentOS" or os=="RedHat" %}
  - repos.nginx
{% endif %}

selinux-policy-targeted:
  pkg.installed

policycoreutils-python:
  pkg.installed

httpd_can_network_connect:
  selinux.boolean:
    - value: True
    - persist: True

python-virtualenv:
  pkg.installed

/root/salt/scripts/build_saltpad.sh:
  file.managed:
    - makedirs: true
    - source: salt://roles/build/saltpad/build_saltpad.sh
    - user: root
    - group: root
    - mode: 744

build_saltpad:
  cmd.run:
    - name: "sh /root/salt/scripts/build_saltpad.sh"

/root/salt/scripts/start_saltpad.sh:
  file.managed:
    - source: salt://roles/build/saltpad/start_saltpad.sh
    - user: root
    - group: root
    - mode: 744

/usr/lib/systemd/system/saltpad.service:
  file.managed:
    - source: salt://roles/build/saltpad/saltpad.service
    - user: root
    - group: root
    - mode: 644

install_nginx:
  pkg.installed:
    - name: nginx
